//
// Miscellaneous functions for DJ lib
//


//
// Extract a token from another based on delimiter
//
// This is a stub function for the one in FunckyII referenced
// by DJ.lib
//
// Note that this function only handles the simple case of
// a single delimiter since this is all that DJ.lib requires
//
// For example:
//
//   strextract( "CGTIMES__12", "_", 3 ) returns "12"
//   strextract( "CGTIMES__12", "_", 2 ) returns ""
//   strextract( "__12", "_", 3 )        returns "12"
//
function strextract( cStr, cDelim, nOccur )

   local cRetval     := ""    ,;     // Return value, defaults to ""
         nCnt        := 0     ,;     // Counter for tokens extracted
         nPos        := NIL   ,;
         lContinue   := .T.   ,;
         cTok        := NIL

   // Keep extracting and truncating until token found or string exhausted
   while ( lContinue .and.  !empty(cStr) )

      nCnt++
      nPos := at( cDelim, cStr )

      if ( nPos > 0 )
         if (nPos == 1)
            cTok := ""
         else
            cTok := substr( cStr, 1, nPos-1 )
         endif

         if ( nCnt == nOccur )
            cRetval   := cTok
            lContinue := .F.
         else
            cStr := substr( cStr, nPos + 1 )
         endif

      else

         if ( nCnt == nOccur )
            cRetval := cStr
         endif

         lContinue := .F.

      endif

   enddo

return( cRetval )


